
import 'package:flutter/material.dart';

/// 结构化的日期数据
class DayStructure {
  final int index; // 下标
  final DateTime date; // 日期
  final bool isToday; // 是否是当天
  final bool isCurrentMonth; // 是否是当月
  bool hasSchedule; // 是否包含日程
  bool isSelected; // 是否选中

  DayStructure({
    required this.index,
    required this.date,
    this.isToday = false,
    this.isCurrentMonth = true,
    this.isSelected = false,
    this.hasSchedule = false,
  });

  setSelected() {
    isSelected = true;
  }

  setUnselected() {
    isSelected = false;
  }
}

/// 结构化的日程类型数据：类型名称，类型是否选中，类型颜色
class ScheduleType {
  final String typeName; // 类型名称
  final Color color; // 类型颜色
  bool isSelected; // 类型是否选中

  ScheduleType({
    required this.typeName,
    required this.isSelected,
    required this.color,
  });
}
